
/*
 *    EXECLOCK.C
 *
 *    Usage: execlock file program args
 *
 *    -fails if lock already exist
 *    -flocks the file
 *    -runs the program
 *    -waits for it to exit
 */

#include <stdio.h>
#include <sys/file.h>

main(ac,av)
char *av[];
{
    int fd = open(av[1], O_RDWR|O_CREAT, 0777);

    if (fd < 0) {
	fputs("0 Unable to open/create the file\n", stderr);
	exit(1);
    }
    if (flock(fd, LOCK_NB|LOCK_EX) < 0) {
	fputs("1 Lock in use, program not run\n", stderr);
	exit(2);
    }
    if (fork() == 0) {
	close(fd);
        execvp(av[2], av + 2);
	fputs("2 exec failed\n", stderr);
    }
    wait(0);
    close(fd);	/* not really needed */
}

